; Contribution to the #amycoders fastest 
; triangle compo by Blueberry of Efreet.

FastTriangle_MaxLongs = 31	; Max 127 pixels wide.

FastTriangle_MakeTable:
	lea.l	TriTable,a2
	clr.l	d5
	move.w	#255,d7
.loop1:	move.w	d7,d6
.loop2:	move.w	d7,d5
	lsl.w	#8,d5
	move.b	d6,d5
	lea.l	(a2,d5.l*8),a0
	ror.w	#8,d5
	lea.l	(a2,d5.l*8),a1
	move.w	d6,d0
	move.w	d7,d1

	move.w	d0,(a0)+	; Left x
	move.w	d0,(a1)+
	move.w	d0,d2
	subq.w	#1,d2
	and.w	#3,d2
	addq.w	#3,d0
	and.w	#-4,d0
	move.w	d1,d3
	not.w	d3
	and.w	#3,d3
	and.w	#-4,d1
	sub.w	d0,d1
	bpl.b	.yes
	; Start and end in same longword.
	moveq.l	#3,d2
	add.w	d6,d2
	sub.w	d7,d2
	moveq.l	#3,d3
	clr.w	d1
.yes:	lsr.w	#2,d1
	neg.w	d1
	add.w	#FastTriangle_MaxLongs,d1
	move.w	d2,(a0)+	; Left bytes
	move.w	d2,(a1)+
	move.w	d1,(a0)+	; Longwords
	move.w	d1,(a1)+
	move.w	d3,(a0)+	; Right bytes
	move.w	d3,(a1)+
	dbf	d6,.loop2
	dbf	d7,.loop1
	rts

FastTriangle:
.lscrw	=	8		; log2(ScreenWidth)
	lea.l	TriTable,a2

	; Extend the color to the whole reg.
	move.b	d0,d1
	lsl.w	#8,d0
	move.b	d1,d0
	move.w	d0,d1
	swap.w	d0
	move.w	d1,d0

	; Get the corners, and sort them...
	movem.w	(a1),d1-d6
	cmp.w	d2,d4
	bge.b	.ok1
	exg.l	d1,d3
	exg.l	d2,d4
.ok1:	cmp.w	d2,d6
	bge.b	.ok2
	exg.l	d1,d5
	exg.l	d2,d6
.ok2:	cmp.w	d4,d6
	bge.b	.ok3
	exg.l	d3,d5
	exg.l	d4,d6
.ok3:	move.w	d5,-(a7)
	move.w	d3,-(a7)

	; Calculate delta values...
	sub.l	d1,d3		; x2-x1
	sub.l	d2,d4		; y2-y1
	sub.l	d1,d5		; x3-x1
	sub.l	d2,d6		; y3-y1
	beq.w	.end		; No triangle?
	lsl.l	#.lscrw,d2
	lsl.l	#8,d3
	lsl.l	#8,d5
	add.l	d2,a0		; Start line
	divs.w	d6,d5		; delta x 1
	move.l	d1,d2		; edge x 1
	move.w	d6,a6
	swap.w	d1
	swap.w	d5
	move.w	#$8080,d1	; Rounding
	sub.w	d4,a6		; Length of second part
	clr.w	d5
	ror.l	#8,d1		; edge x 2
	rol.l	#8,d5		; dx1f.0.0.dx1i
	tst.w	d4
	move.l	d5,a3
	beq.w	.next		; No first part?
	divs.w	d4,d3		; delta x 2
	move.l	a3,d6
	move.w	d3,d6
	move.l	d6,a3		; dx1f.0.dx2i.dx2f

.loop1:	clr.l	d3
	subq.w	#1,d4
.loop2:	move.w	d1,d3
	move.l	a0,a5
	move.b	d2,d3	; x2i.x1i
	lea.l	(a2,d3.l*8),a4
	add.w	(a4)+,a5
	move.w	(a4)+,d6
	move.w	(a4)+,d3
	move.w	(a4)+,d7
	jmp	.j1(pc,d6.w*2)
.j1:	move.b	d0,(a5)+
	move.b	d0,(a5)+
	move.b	d0,(a5)+
	jmp	.j2(pc,d3.w*2)
.j2:	rept	FastTriangle_MaxLongs
	move.l	d0,(a5)+
	endr
	jmp	.j3(pc,d7.w*2)
.j3:	move.b	d0,(a5)+
	move.b	d0,(a5)+
	move.b	d0,(a5)+

	add.l	a3,d1
	addx.b	d5,d2
	lea.l	1<<.lscrw(a0),a0
	dbf	d4,.loop2
.next:
	; Do second part...
	move.w	a6,d4
	beq.b	.end		; No second part?
	suba.l	a6,a6
	move.w	(a7),d1		; x2
	move.w	2(a7),d7	; x3
	sub.w	d1,d7
	lsl.w	#8,d1		; edge x 2 (second part)
	ext.l	d7
	move.b	#$80,d1		; Rounding
	lsl.l	#8,d7
	divs.w	d4,d7		; delta x 2
	move.l	a3,d6
	move.w	d7,d6
	move.l	d6,a3		; dx1f.0.dx2i.dx2f
	bra.w	.loop1
.end:	addq.l	#4,a7
	rts

	section	Table,bss_f

TriTable:
	ds.w	256*256*4
