;
; by Mikael Kalms (kalms@dataphone.se)
;
; This is a general flatpoly routine, no special optimizations for
; extreme poly-sizes or 256x256 chunkyscreens made
;

	section	code,code

fpolydrawtri_init
	lea	invtab,a0
	move.l	#$00004000,(a0)+
	move.w	#2,d0
.invloop
	move.l	#$4000,d1
	divs.w	d0,d1
	move.w	d1,(a0)+
	addq.w	#1,d0
	cmpi.w	#1024,d0
	blo.s	.invloop
	rts

	cnop	0,16
fpolydrawtri
;	cmp.w	#.size1-.size0,d0
.size0
	move.b	d0,d7
	lsl.w	#8,d7
	move.b	d0,d7

	movem.l	(a1),d0-d2

	cmp.w	d0,d1
	bge.s	.nexg1
	exg	d0,d1
.nexg1	cmp.w	d0,d2
	bge.s	.nexg2
	exg	d0,d2
.nexg2	cmp.w	d1,d2
	bge.s	.nexg3
	exg	d1,d2
.nexg3
	move.w	#CHUNKYXMAX,a2
	move.w	d0,d4
	muls.w	#CHUNKYXMAX,d4
	lea	(a0,d4.l),a1

	lea	invtab,a0

	move.w	d1,d3
	move.w	d2,d4
	move.w	d2,d5
	sub.w	d0,d3
	beq	.flattop
	sub.w	d0,d4
	sub.w	d1,d5

	clr.w	d0
	move.l	d0,d6
	clr.w	d1
	move.l	d1,a6

	swap	d0
	swap	d1
	swap	d2

	sub.w	d0,d1
	sub.w	d0,d2
	move.w	d2,d0
	sub.w	d1,d0

	muls.w	(a0,d3.w*2),d1
	muls.w	(a0,d4.w*2),d2
	lsl.l	#2,d1
	lsl.l	#2,d2
	tst.w	d5
	beq.s	.flatbot
	muls.w	(a0,d5.w*2),d0
	lsl.l	#2,d0
.flatbot

; d0	dx3/dy3 << 16
; d1	dx1/dy1 << 16
; d2	dx2/dy2 << 16
; d3.w	dy1
; d4.w	dy2
; d5.w	dy3

	move.l	d1,a3
	move.l	d2,a4
	move.l	d0,a5

	move.w	d5,d4
	move.l	d6,d5

	cmp.l	d1,d2
	blt.s	.reversed1

	move.w	d3,d0
	bsr.s	.fill

	move.w	d4,d0
	beq.s	.npoly
	move.l	a5,a3
	move.l	a6,d5
	bsr.s	.fill
.npoly	rts

.reversed1
	exg	a3,a4
	move.w	d3,d0
	bsr.s	.fill

	move.w	d4,d0
	beq.s	.npoly
	move.l	a5,a4
	move.l	a6,d6
	bsr.s	.fill
	rts

.fill	subq.w	#1,d0
.line	add.l	a3,d5
	add.l	a4,d6

	move.l	d5,d1
	move.l	d6,d2
	swap	d1
	swap	d2

.fillinternal
	sub.w	d1,d2
	bmi.s	.npix
	lea	(a1,d1.w),a0
	lsr.w	#1,d2
	bcs.s	.pix
	move.b	d7,(a0)+
	subq.w	#1,d2
	bmi.s	.npix
.pix	move.w	d7,(a0)+
	dbf	d2,.pix
.npix
.nline	add.l	a2,a1
	dbf	d0,.line
.nfill	rts

.flattop
	sub.w	d1,d5
	beq.s	.npoly
	clr.w	d0
	clr.w	d1
	clr.w	d2
	move.w	d5,d3
	move.l	d0,d5
	move.l	d1,d6

	sub.l	d2,d0
	neg.l	d0
	sub.l	d1,d2
	swap	d0
	swap	d2

	muls.w	(a0,d3.w*2),d0
	muls.w	(a0,d3.w*2),d2
	lsl.l	#2,d0
	lsl.l	#2,d2
	cmp.l	d0,d2
	blt.s	.nreversed2
	exg	d5,d6
	exg	d0,d2
.nreversed2
	move.l	d0,a3
	move.l	d2,a4

	move.w	d3,d0
	bsr.s	.fill
	rts
.size1

	section	bss,bss

invtab	ds.w	1024
